Index: applications/editors/josm/plugins/turnlanes/src/org/openstreetmap/josm/plugins/turnlanes/gui/GuiContainer.java
===================================================================
--- applications/editors/josm/plugins/turnlanes/src/org/openstreetmap/josm/plugins/turnlanes/gui/GuiContainer.java	(revision 25908)
+++ applications/editors/josm/plugins/turnlanes/src/org/openstreetmap/josm/plugins/turnlanes/gui/GuiContainer.java	(revision 26154)
@@ -24,157 +24,157 @@
 
 class GuiContainer {
-	static final Color RED = new Color(234, 66, 108);
-	static final Color GREEN = new Color(66, 234, 108);
-	
-	private final ModelContainer mc;
-	
-	private final Point2D translation;
-	/**
-	 * Meters per pixel.
-	 */
-	private final double mpp;
-	private final double scale;
-	private final double laneWidth;
-	
-	private final Map<Junction, JunctionGui> junctions = new HashMap<Junction, JunctionGui>();
-	private final Map<Road, RoadGui> roads = new HashMap<Road, RoadGui>();
-	
-	private final Stroke connectionStroke;
-	
-	public GuiContainer(ModelContainer mc) {
-		final Point2D origin = avgOrigin(locs(mc.getPrimaryJunctions()));
-		
-		final LatLon originCoor = Main.proj.eastNorth2latlon(new EastNorth(origin.getX(), origin.getY()));
-		final LatLon relCoor = Main.proj.eastNorth2latlon(new EastNorth(origin.getX() + 1, origin.getY() + 1));
-		
-		// meters per source unit
-		final double mpsu = relCoor.greatCircleDistance(originCoor) / sqrt(2);
-		
-		this.mc = mc;
-		this.translation = new Point2D.Double(-origin.getX(), -origin.getY());
-		this.mpp = 0.2;
-		this.scale = mpsu / mpp;
-		this.laneWidth = 2 / mpp;
-		
-		this.connectionStroke = new BasicStroke((float) (laneWidth / 4), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
-		
-		for (Junction j : mc.getPrimaryJunctions()) {
-			getGui(j);
-		}
-	}
-	
-	private static Point2D avgOrigin(List<Point2D> locs) {
-		double x = 0;
-		double y = 0;
-		
-		for (Point2D l : locs) {
-			x += l.getX();
-			y += l.getY();
-		}
-		
-		return new Point2D.Double(x / locs.size(), y / locs.size());
-	}
-	
-	public JunctionGui getGui(Junction j) {
-		final JunctionGui existing = junctions.get(j);
-		if (existing != null) {
-			return existing;
-		}
-		
-		return new JunctionGui(this, j);
-	}
-	
-	void register(JunctionGui j) {
-		if (junctions.put(j.getModel(), j) != null) {
-			throw new IllegalStateException();
-		}
-	}
-	
-	public RoadGui getGui(Road r) {
-		final RoadGui gui = roads.get(r);
-		
-		if (gui == null) {
-			final RoadGui newGui = new RoadGui(this, r);
-			roads.put(r, newGui);
-			return newGui;
-		}
-		
-		return gui;
-	}
-	
-	Point2D translateAndScale(Point2D loc) {
-		return new Point2D.Double((loc.getX() + translation.getX()) * scale, (loc.getY() + translation.getY()) * scale);
-	}
-	
-	/**
-	 * @return meters per pixel
-	 */
-	public double getMpp() {
-		return mpp;
-	}
-	
-	public double getScale() {
-		return scale;
-	}
-	
-	public double getLaneWidth() {
-		return laneWidth;
-	}
-	
-	public Stroke getConnectionStroke() {
-		return connectionStroke;
-	}
-	
-	public LaneGui getGui(Lane lane) {
-		final RoadGui roadGui = roads.get(lane.getRoad());
-		
-		for (LaneGui l : roadGui.getLanes()) {
-			if (l.getModel().equals(lane)) {
-				return l;
-			}
-		}
-		
-		throw new IllegalArgumentException("No such lane.");
-	}
-	
-	public ModelContainer getModel() {
-		return mc;
-	}
-	
-	public Rectangle2D getBounds() {
-		final List<Junction> primaries = new ArrayList<Junction>(mc.getPrimaryJunctions());
-		final List<Double> top = new ArrayList<Double>();
-		final List<Double> left = new ArrayList<Double>();
-		final List<Double> right = new ArrayList<Double>();
-		final List<Double> bottom = new ArrayList<Double>();
-		
-		for (Junction j : primaries) {
-			final JunctionGui g = getGui(j);
-			final Rectangle2D b = g.getBounds();
-			
-			top.add(b.getMinY());
-			left.add(b.getMinX());
-			right.add(b.getMaxX());
-			bottom.add(b.getMaxY());
-		}
-		
-		final double t = Collections.min(top);
-		final double l = Collections.min(left);
-		final double r = Collections.max(right);
-		final double b = Collections.max(bottom);
-		
-		return new Rectangle2D.Double(l, t, r - l, b - t);
-	}
-	
-	public GuiContainer recalculate() {
-		return new GuiContainer(mc.recalculate());
-	}
-	
-	public Iterable<RoadGui> getRoads() {
-		return roads.values();
-	}
-	
-	public Iterable<JunctionGui> getJunctions() {
-		return junctions.values();
-	}
+    static final Color RED = new Color(234, 66, 108);
+    static final Color GREEN = new Color(66, 234, 108);
+    
+    private final ModelContainer mc;
+    
+    private final Point2D translation;
+    /**
+     * Meters per pixel.
+     */
+    private final double mpp;
+    private final double scale;
+    private final double laneWidth;
+    
+    private final Map<Junction, JunctionGui> junctions = new HashMap<Junction, JunctionGui>();
+    private final Map<Road, RoadGui> roads = new HashMap<Road, RoadGui>();
+    
+    private final Stroke connectionStroke;
+    
+    public GuiContainer(ModelContainer mc) {
+        final Point2D origin = avgOrigin(locs(mc.getPrimaryJunctions()));
+        
+        final LatLon originCoor = Main.getProjection().eastNorth2latlon(new EastNorth(origin.getX(), origin.getY()));
+        final LatLon relCoor = Main.getProjection().eastNorth2latlon(new EastNorth(origin.getX() + 1, origin.getY() + 1));
+        
+        // meters per source unit
+        final double mpsu = relCoor.greatCircleDistance(originCoor) / sqrt(2);
+        
+        this.mc = mc;
+        this.translation = new Point2D.Double(-origin.getX(), -origin.getY());
+        this.mpp = 0.2;
+        this.scale = mpsu / mpp;
+        this.laneWidth = 2 / mpp;
+        
+        this.connectionStroke = new BasicStroke((float) (laneWidth / 4), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
+        
+        for (Junction j : mc.getPrimaryJunctions()) {
+            getGui(j);
+        }
+    }
+    
+    private static Point2D avgOrigin(List<Point2D> locs) {
+        double x = 0;
+        double y = 0;
+        
+        for (Point2D l : locs) {
+            x += l.getX();
+            y += l.getY();
+        }
+        
+        return new Point2D.Double(x / locs.size(), y / locs.size());
+    }
+    
+    public JunctionGui getGui(Junction j) {
+        final JunctionGui existing = junctions.get(j);
+        if (existing != null) {
+            return existing;
+        }
+        
+        return new JunctionGui(this, j);
+    }
+    
+    void register(JunctionGui j) {
+        if (junctions.put(j.getModel(), j) != null) {
+            throw new IllegalStateException();
+        }
+    }
+    
+    public RoadGui getGui(Road r) {
+        final RoadGui gui = roads.get(r);
+        
+        if (gui == null) {
+            final RoadGui newGui = new RoadGui(this, r);
+            roads.put(r, newGui);
+            return newGui;
+        }
+        
+        return gui;
+    }
+    
+    Point2D translateAndScale(Point2D loc) {
+        return new Point2D.Double((loc.getX() + translation.getX()) * scale, (loc.getY() + translation.getY()) * scale);
+    }
+    
+    /**
+     * @return meters per pixel
+     */
+    public double getMpp() {
+        return mpp;
+    }
+    
+    public double getScale() {
+        return scale;
+    }
+    
+    public double getLaneWidth() {
+        return laneWidth;
+    }
+    
+    public Stroke getConnectionStroke() {
+        return connectionStroke;
+    }
+    
+    public LaneGui getGui(Lane lane) {
+        final RoadGui roadGui = roads.get(lane.getRoad());
+        
+        for (LaneGui l : roadGui.getLanes()) {
+            if (l.getModel().equals(lane)) {
+                return l;
+            }
+        }
+        
+        throw new IllegalArgumentException("No such lane.");
+    }
+    
+    public ModelContainer getModel() {
+        return mc;
+    }
+    
+    public Rectangle2D getBounds() {
+        final List<Junction> primaries = new ArrayList<Junction>(mc.getPrimaryJunctions());
+        final List<Double> top = new ArrayList<Double>();
+        final List<Double> left = new ArrayList<Double>();
+        final List<Double> right = new ArrayList<Double>();
+        final List<Double> bottom = new ArrayList<Double>();
+        
+        for (Junction j : primaries) {
+            final JunctionGui g = getGui(j);
+            final Rectangle2D b = g.getBounds();
+            
+            top.add(b.getMinY());
+            left.add(b.getMinX());
+            right.add(b.getMaxX());
+            bottom.add(b.getMaxY());
+        }
+        
+        final double t = Collections.min(top);
+        final double l = Collections.min(left);
+        final double r = Collections.max(right);
+        final double b = Collections.max(bottom);
+        
+        return new Rectangle2D.Double(l, t, r - l, b - t);
+    }
+    
+    public GuiContainer recalculate() {
+        return new GuiContainer(mc.recalculate());
+    }
+    
+    public Iterable<RoadGui> getRoads() {
+        return roads.values();
+    }
+    
+    public Iterable<JunctionGui> getJunctions() {
+        return junctions.values();
+    }
 }
Index: applications/editors/josm/plugins/turnlanes/src/org/openstreetmap/josm/plugins/turnlanes/gui/GuiUtil.java
===================================================================
--- applications/editors/josm/plugins/turnlanes/src/org/openstreetmap/josm/plugins/turnlanes/gui/GuiUtil.java	(revision 25908)
+++ applications/editors/josm/plugins/turnlanes/src/org/openstreetmap/josm/plugins/turnlanes/gui/GuiUtil.java	(revision 26154)
@@ -17,133 +17,133 @@
 
 class GuiUtil {
-	static double normalize(double a) {
-		while (a < 0) {
-			a += 2 * Math.PI;
-		}
-		while (a > 2 * Math.PI) {
-			a -= 2 * Math.PI;
-		}
-		return a;
-	}
-	
-	// control point factor for curves (circle segment of angle a)
-	static double cpf(double a, double scale) {
-		return 4.0 / 3 * Math.tan(min(abs(a), PI - 0.001) / 4) * scale;
-	}
-	
-	static Point2D intersection(Line2D a, Line2D b) {
-		final double aa = GuiUtil.angle(a);
-		final double ab = GuiUtil.angle(b);
-		
-		// less than 1/2 degree => no intersection
-		if (Math.abs(Math.PI - abs(minAngleDiff(aa, ab))) < PI / 360) {
-			return null;
-		}
-		
-		final double d = (a.getX1() - a.getX2()) * (b.getY1() - b.getY2()) - (a.getY1() - a.getY2())
-		    * (b.getX1() - b.getX2());
-		
-		final double x = ((b.getX1() - b.getX2()) * (a.getX1() * a.getY2() - a.getY1() * a.getX2()) - (a.getX1() - a
-		    .getX2()) * (b.getX1() * b.getY2() - b.getY1() * b.getX2()))
-		    / d;
-		final double y = ((b.getY1() - b.getY2()) * (a.getX1() * a.getY2() - a.getY1() * a.getX2()) - (a.getY1() - a
-		    .getY2()) * (b.getX1() * b.getY2() - b.getY1() * b.getX2()))
-		    / d;
-		
-		return new Point2D.Double(x, y);
-	}
-	
-	static Point2D closest(Line2D l, Point2D p) {
-		final Point2D lv = vector(l.getP1(), l.getP2());
-		final double numerator = dot(vector(l.getP1(), p), lv);
-		
-		if (numerator < 0) {
-			return l.getP1();
-		}
-		
-		final double denominator = dot(lv, lv);
-		if (numerator >= denominator) {
-			return l.getP2();
-		}
-		
-		final double r = numerator / denominator;
-		return new Point2D.Double(l.getX1() + r * lv.getX(), l.getY1() + r * lv.getY());
-	}
-	
-	private static double dot(Point2D a, Point2D b) {
-		return a.getX() * b.getX() + a.getY() * b.getY();
-	}
-	
-	private static Point2D vector(Point2D from, Point2D to) {
-		return new Point2D.Double(to.getX() - from.getX(), to.getY() - from.getY());
-	}
-	
-	public static double angle(Point2D from, Point2D to) {
-		final double dx = to.getX() - from.getX();
-		final double dy = -(to.getY() - from.getY());
-		
-		return normalize(Math.atan2(dy, dx));
-	}
-	
-	public static Point2D relativePoint(Point2D p, double r, double a) {
-		return new Point2D.Double( //
-		    p.getX() + r * Math.cos(a), //
-		    p.getY() - r * Math.sin(a) //
-		);
-	}
-	
-	public static Line2D relativeLine(Line2D l, double r, double a) {
-		final double dx = r * Math.cos(a);
-		final double dy = -r * Math.sin(a);
-		
-		return new Line2D.Double( //
-		    l.getX1() + dx, //
-		    l.getY1() + dy, //
-		    l.getX2() + dx, //
-		    l.getY2() + dy //
-		);
-	}
-	
-	public static double angle(Line2D l) {
-		return angle(l.getP1(), l.getP2());
-	}
-	
-	public static double minAngleDiff(double a1, double a2) {
-		final double d = normalize(a2 - a1);
-		
-		return d > Math.PI ? -(2 * Math.PI - d) : d;
-	}
-	
-	public static final Point2D middle(Point2D a, Point2D b) {
-		return relativePoint(a, a.distance(b) / 2, angle(a, b));
-	}
-	
-	public static final Point2D middle(Line2D l) {
-		return middle(l.getP1(), l.getP2());
-	}
-	
-	public static Line2D line(Point2D p, double a) {
-		return new Line2D.Double(p, relativePoint(p, 1, a));
-	}
-	
-	public static Point2D loc(Node node) {
-		final EastNorth loc = Main.proj.latlon2eastNorth(node.getCoor());
-		return new Point2D.Double(loc.getX(), -loc.getY());
-	}
-	
-	public static List<Point2D> locs(Iterable<Junction> junctions) {
-		final List<Point2D> locs = new ArrayList<Point2D>();
-		
-		for (Junction j : junctions) {
-			locs.add(loc(j.getNode()));
-		}
-		
-		return locs;
-	}
-	
-	static void area(Path2D area, Path inner, Path outer) {
-		area.append(inner.getIterator(), false);
-		area.append(ReversePathIterator.reverse(outer.getIterator()), true);
-		area.closePath();
-	}
+    static double normalize(double a) {
+        while (a < 0) {
+            a += 2 * Math.PI;
+        }
+        while (a > 2 * Math.PI) {
+            a -= 2 * Math.PI;
+        }
+        return a;
+    }
+    
+    // control point factor for curves (circle segment of angle a)
+    static double cpf(double a, double scale) {
+        return 4.0 / 3 * Math.tan(min(abs(a), PI - 0.001) / 4) * scale;
+    }
+    
+    static Point2D intersection(Line2D a, Line2D b) {
+        final double aa = GuiUtil.angle(a);
+        final double ab = GuiUtil.angle(b);
+        
+        // less than 1/2 degree => no intersection
+        if (Math.abs(Math.PI - abs(minAngleDiff(aa, ab))) < PI / 360) {
+            return null;
+        }
+        
+        final double d = (a.getX1() - a.getX2()) * (b.getY1() - b.getY2()) - (a.getY1() - a.getY2())
+            * (b.getX1() - b.getX2());
+        
+        final double x = ((b.getX1() - b.getX2()) * (a.getX1() * a.getY2() - a.getY1() * a.getX2()) - (a.getX1() - a
+            .getX2()) * (b.getX1() * b.getY2() - b.getY1() * b.getX2()))
+            / d;
+        final double y = ((b.getY1() - b.getY2()) * (a.getX1() * a.getY2() - a.getY1() * a.getX2()) - (a.getY1() - a
+            .getY2()) * (b.getX1() * b.getY2() - b.getY1() * b.getX2()))
+            / d;
+        
+        return new Point2D.Double(x, y);
+    }
+    
+    static Point2D closest(Line2D l, Point2D p) {
+        final Point2D lv = vector(l.getP1(), l.getP2());
+        final double numerator = dot(vector(l.getP1(), p), lv);
+        
+        if (numerator < 0) {
+            return l.getP1();
+        }
+        
+        final double denominator = dot(lv, lv);
+        if (numerator >= denominator) {
+            return l.getP2();
+        }
+        
+        final double r = numerator / denominator;
+        return new Point2D.Double(l.getX1() + r * lv.getX(), l.getY1() + r * lv.getY());
+    }
+    
+    private static double dot(Point2D a, Point2D b) {
+        return a.getX() * b.getX() + a.getY() * b.getY();
+    }
+    
+    private static Point2D vector(Point2D from, Point2D to) {
+        return new Point2D.Double(to.getX() - from.getX(), to.getY() - from.getY());
+    }
+    
+    public static double angle(Point2D from, Point2D to) {
+        final double dx = to.getX() - from.getX();
+        final double dy = -(to.getY() - from.getY());
+        
+        return normalize(Math.atan2(dy, dx));
+    }
+    
+    public static Point2D relativePoint(Point2D p, double r, double a) {
+        return new Point2D.Double( //
+            p.getX() + r * Math.cos(a), //
+            p.getY() - r * Math.sin(a) //
+        );
+    }
+    
+    public static Line2D relativeLine(Line2D l, double r, double a) {
+        final double dx = r * Math.cos(a);
+        final double dy = -r * Math.sin(a);
+        
+        return new Line2D.Double( //
+            l.getX1() + dx, //
+            l.getY1() + dy, //
+            l.getX2() + dx, //
+            l.getY2() + dy //
+        );
+    }
+    
+    public static double angle(Line2D l) {
+        return angle(l.getP1(), l.getP2());
+    }
+    
+    public static double minAngleDiff(double a1, double a2) {
+        final double d = normalize(a2 - a1);
+        
+        return d > Math.PI ? -(2 * Math.PI - d) : d;
+    }
+    
+    public static final Point2D middle(Point2D a, Point2D b) {
+        return relativePoint(a, a.distance(b) / 2, angle(a, b));
+    }
+    
+    public static final Point2D middle(Line2D l) {
+        return middle(l.getP1(), l.getP2());
+    }
+    
+    public static Line2D line(Point2D p, double a) {
+        return new Line2D.Double(p, relativePoint(p, 1, a));
+    }
+    
+    public static Point2D loc(Node node) {
+        final EastNorth loc = Main.getProjection().latlon2eastNorth(node.getCoor());
+        return new Point2D.Double(loc.getX(), -loc.getY());
+    }
+    
+    public static List<Point2D> locs(Iterable<Junction> junctions) {
+        final List<Point2D> locs = new ArrayList<Point2D>();
+        
+        for (Junction j : junctions) {
+            locs.add(loc(j.getNode()));
+        }
+        
+        return locs;
+    }
+    
+    static void area(Path2D area, Path inner, Path outer) {
+        area.append(inner.getIterator(), false);
+        area.append(ReversePathIterator.reverse(outer.getIterator()), true);
+        area.closePath();
+    }
 }
Index: applications/editors/josm/plugins/turnlanes/src/org/openstreetmap/josm/plugins/turnlanes/gui/TurnLanesDialog.java
===================================================================
--- applications/editors/josm/plugins/turnlanes/src/org/openstreetmap/josm/plugins/turnlanes/gui/TurnLanesDialog.java	(revision 25908)
+++ applications/editors/josm/plugins/turnlanes/src/org/openstreetmap/josm/plugins/turnlanes/gui/TurnLanesDialog.java	(revision 26154)
@@ -18,4 +18,5 @@
 
 import org.openstreetmap.josm.actions.JosmAction;
+import org.openstreetmap.josm.Main;
 import org.openstreetmap.josm.data.SelectionChangedListener;
 import org.openstreetmap.josm.data.osm.DataSet;
@@ -27,105 +28,117 @@
 
 public class TurnLanesDialog extends ToggleDialog {
-	private final Action editAction = new JosmAction(tr("Edit"), "dialogs/edit",
-	    tr("Edit turn relations and lane lengths for selected node."), null, true) {
-		
-		private static final long serialVersionUID = 4114119073563457706L;
-		
-		@Override
-		public void actionPerformed(ActionEvent e) {
-			final CardLayout cl = (CardLayout) body.getLayout();
-			cl.show(body, CARD_EDIT);
-			editing = true;
-		}
-	};
-	private final Action validateAction = new JosmAction(tr("Validate"), "dialogs/validator",
-	    tr("Validate turn- and lane-length-relations for consistency."), null, true) {
-		
-		private static final long serialVersionUID = 7510740945725851427L;
-		
-		@Override
-		public void actionPerformed(ActionEvent e) {
-			final CardLayout cl = (CardLayout) body.getLayout();
-			cl.show(body, CARD_VALIDATE);
-			editing = false;
-		}
-	};
-	
-	private static final long serialVersionUID = -1998375221636611358L;
-	
-	private static final String CARD_EDIT = "EDIT";
-	private static final String CARD_VALIDATE = "VALIDATE";
-	private static final String CARD_ERROR = "ERROR";
-	
-	private final JPanel body = new JPanel();
-	private final JunctionPane junctionPane = new JunctionPane(null);
-	private final JLabel error = new JLabel();
-	
-	private boolean editing = true;
-	
-	public TurnLanesDialog() {
-		super(tr("Turn Lanes"), "turnlanes.png", tr("Edit turn lanes"), null, 200);
-		
-		DataSet.addSelectionListener(new SelectionChangedListener() {
-			@Override
-			public void selectionChanged(Collection<? extends OsmPrimitive> newSelection) {
-				final Collection<OsmPrimitive> s = Collections.unmodifiableCollection(newSelection);
-				final List<Node> nodes = OsmPrimitive.getFilteredList(s, Node.class);
-				final List<Way> ways = OsmPrimitive.getFilteredList(s, Way.class);
-				
-				if (nodes.isEmpty()) {
-					setJunction(null);
-					return;
-				}
-				
-				try {
-					setJunction(ModelContainer.create(nodes, ways));
-				} catch (RuntimeException e) {
-					displayError(e);
-					return;
-				}
-			}
-		});
-		
-		final JPanel buttonPanel = new JPanel(new GridLayout(1, 2, 4, 4));
-		final ButtonGroup group = new ButtonGroup();
-		final JToggleButton editButton = new JToggleButton(editAction);
-		final JToggleButton validateButton = new JToggleButton(validateAction);
-		group.add(editButton);
-		group.add(validateButton);
-		buttonPanel.add(editButton);
-		buttonPanel.add(validateButton);
-		
-		body.setLayout(new CardLayout(4, 4));
-		
-		add(buttonPanel, BorderLayout.SOUTH);
-		add(body, BorderLayout.CENTER);
-		
-		body.add(junctionPane, CARD_EDIT);
-		body.add(new ValidationPanel(), CARD_VALIDATE);
-		body.add(error, CARD_ERROR);
-		
-		editButton.doClick();
-	}
-	
-	void displayError(RuntimeException e) {
-		if (editing) {
-			e.printStackTrace();
-			
-			error.setText("<html>An error occured while constructing the model."
-			    + " Please run the validator to make sure the data is consistent.<br><br>Error: " + e.getMessage()
-			    + "</html>");
-			
-			final CardLayout cl = (CardLayout) body.getLayout();
-			cl.show(body, CARD_ERROR);
-		}
-	}
-	
-	void setJunction(ModelContainer mc) {
-		if (mc != null && editing) {
-			junctionPane.setJunction(new GuiContainer(mc));
-			final CardLayout cl = (CardLayout) body.getLayout();
-			cl.show(body, CARD_EDIT);
-		}
-	}
+    private class EditAction extends JosmAction {
+        private static final long serialVersionUID = 4114119073563457706L;
+        public EditAction() {
+            super(tr("Edit"), "dialogs/edit",
+            tr("Edit turn relations and lane lengths for selected node."), null, false);
+            putValue("toolbar", "turnlanes/edit");
+            Main.toolbar.register(this);
+        }
+
+        @Override
+        public void actionPerformed(ActionEvent e) {
+            final CardLayout cl = (CardLayout) body.getLayout();
+            cl.show(body, CARD_EDIT);
+            editing = true;
+        }
+    }
+
+    private class ValidateAction extends JosmAction {
+        private static final long serialVersionUID = 7510740945725851427L;
+        public ValidateAction() {
+            super(tr("Validate"), "dialogs/validator",
+            tr("Validate turn- and lane-length-relations for consistency."), null, false);
+            putValue("toolbar", "turnlanes/validate");
+            Main.toolbar.register(this);
+        }
+
+        @Override
+        public void actionPerformed(ActionEvent e) {
+            final CardLayout cl = (CardLayout) body.getLayout();
+            cl.show(body, CARD_VALIDATE);
+            editing = false;
+        }
+    }
+
+    private final Action editAction = new EditAction();
+    private final Action validateAction = new ValidateAction();
+
+    private static final long serialVersionUID = -1998375221636611358L;
+
+    private static final String CARD_EDIT = "EDIT";
+    private static final String CARD_VALIDATE = "VALIDATE";
+    private static final String CARD_ERROR = "ERROR";
+
+    private final JPanel body = new JPanel();
+    private final JunctionPane junctionPane = new JunctionPane(null);
+    private final JLabel error = new JLabel();
+
+    private boolean editing = true;
+
+    public TurnLanesDialog() {
+        super(tr("Turn Lanes"), "turnlanes.png", tr("Edit turn lanes"), null, 200);
+
+        DataSet.addSelectionListener(new SelectionChangedListener() {
+            @Override
+            public void selectionChanged(Collection<? extends OsmPrimitive> newSelection) {
+                final Collection<OsmPrimitive> s = Collections.unmodifiableCollection(newSelection);
+                final List<Node> nodes = OsmPrimitive.getFilteredList(s, Node.class);
+                final List<Way> ways = OsmPrimitive.getFilteredList(s, Way.class);
+
+                if (nodes.isEmpty()) {
+                    setJunction(null);
+                    return;
+                }
+
+                try {
+                    setJunction(ModelContainer.create(nodes, ways));
+                } catch (RuntimeException e) {
+                    displayError(e);
+                    return;
+                }
+            }
+        });
+
+        final JPanel buttonPanel = new JPanel(new GridLayout(1, 2, 4, 4));
+        final ButtonGroup group = new ButtonGroup();
+        final JToggleButton editButton = new JToggleButton(editAction);
+        final JToggleButton validateButton = new JToggleButton(validateAction);
+        group.add(editButton);
+        group.add(validateButton);
+        buttonPanel.add(editButton);
+        buttonPanel.add(validateButton);
+
+        body.setLayout(new CardLayout(4, 4));
+
+        add(buttonPanel, BorderLayout.SOUTH);
+        add(body, BorderLayout.CENTER);
+
+        body.add(junctionPane, CARD_EDIT);
+        body.add(new ValidationPanel(), CARD_VALIDATE);
+        body.add(error, CARD_ERROR);
+
+        editButton.doClick();
+    }
+
+    void displayError(RuntimeException e) {
+        if (editing) {
+            e.printStackTrace();
+
+            error.setText("<html>An error occured while constructing the model."
+                + " Please run the validator to make sure the data is consistent.<br><br>Error: " + e.getMessage()
+                + "</html>");
+
+            final CardLayout cl = (CardLayout) body.getLayout();
+            cl.show(body, CARD_ERROR);
+        }
+    }
+
+    void setJunction(ModelContainer mc) {
+        if (mc != null && editing) {
+            junctionPane.setJunction(new GuiContainer(mc));
+            final CardLayout cl = (CardLayout) body.getLayout();
+            cl.show(body, CARD_EDIT);
+        }
+    }
 }
